Gentoo Archives: gentoo-commits

From: Nick Sarnie <sarnex@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/proj/wine:master commit in: app-emulation/wine-vanilla/
Date: Sun, 10 May 2020 00:12:19
Message-Id: 1589069423.4250c9a9775c23bc5b72232b868b45a44e317465.sarnex@gentoo
1 commit: 4250c9a9775c23bc5b72232b868b45a44e317465
2 Author: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
3 AuthorDate: Sun May 10 00:10:23 2020 +0000
4 Commit: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
5 CommitDate: Sun May 10 00:10:23 2020 +0000
6 URL: https://gitweb.gentoo.org/repo/proj/wine.git/commit/?id=4250c9a9
7
8 app-emulation/wine-vanilla: Bump to 5.8
9
10 Package-Manager: Portage-2.3.99, Repoman-2.3.22
11 Signed-off-by: Nick Sarnie <sarnex <AT> gentoo.org>
12
13 app-emulation/wine-vanilla/Manifest | 1 +
14 app-emulation/wine-vanilla/wine-vanilla-5.8.ebuild | 539 +++++++++++++++++++++
15 2 files changed, 540 insertions(+)
16
17 diff --git a/app-emulation/wine-vanilla/Manifest b/app-emulation/wine-vanilla/Manifest
18 index 545cc9c..5bcf651 100644
19 --- a/app-emulation/wine-vanilla/Manifest
20 +++ b/app-emulation/wine-vanilla/Manifest
21 @@ -35,3 +35,4 @@ DIST wine-5.4.tar.xz 22917904 BLAKE2B ceaa8516ddc0c2421b92da0ef047465cfa9fc203df
22 DIST wine-5.5.tar.xz 23630916 BLAKE2B 52855c891bb2f6431d0cb02e7b64b28525ad952b548771dd7ff89f95842f9f8e27c941cef7e963b8fb4c7d84c6fd28dba8edfbab90ba683b9f32c41583837e0a SHA512 9c7870dd829effe5fd1be342f85a85e2d1f791bfd871279253dd91becd97dea41c6c4f7a9faec0153e58e360d4e3b4d659daf0d21f07a142d06534e0c229aacd
23 DIST wine-5.6.tar.xz 23678216 BLAKE2B 7aee9a46c037d46d07a551a839056783c020d2e5c66c9caf9c8dacd5071cc9bc9df1c3ea56d6ec07cf83ac681baee6849e786a1202d99f139e1645c374c72704 SHA512 b12b0eff228ecd783fec8bf91f97e4387125226b172046d800e1fbffa303ceca32f1f647b9e8ceb24d303c23eb57188be14ddd8ba5fc04ba781a69186fbe6be4
24 DIST wine-5.7.tar.xz 23723624 BLAKE2B fbea8f753dee57368f7532eef6fe6bf366ba52e9c2b970147207cf879858b86a74d0dfb1f813cfd31058462aaa09f74dd07924370b4c3f032f0dcd0015eab90b SHA512 46a8050cb21edf1116c93fd73fdc3bbbc1a19e18d77c38bc192f13e55954d3e503122c780ca9c1a50005b0bca6f3b0c640f3de05267f25289e08660321e27407
25 +DIST wine-5.8.tar.xz 23753648 BLAKE2B 086f37ce469f6d176eab8daa2d124b1774526727e2f6fe4ecdd39862c13ed493ac4164cf98848d5bc8cba3675e13365f6ea2b34591d518c40c34d09556851578 SHA512 7b9df380655a72e8b9e95ca271a62308262d8efabbeb2ad459071afc9ed51518b42b1f75b019fe8d6b53cf5185e9cfc45ac1b8a7092f118fa2aff14f99c012de
26
27 diff --git a/app-emulation/wine-vanilla/wine-vanilla-5.8.ebuild b/app-emulation/wine-vanilla/wine-vanilla-5.8.ebuild
28 new file mode 100644
29 index 0000000..f1b0c2c
30 --- /dev/null
31 +++ b/app-emulation/wine-vanilla/wine-vanilla-5.8.ebuild
32 @@ -0,0 +1,539 @@
33 +# Copyright 1999-2020 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=6
37 +
38 +PLOCALES="ar ast bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru si sk sl sr_RS@cyrillic sr_RS@latin sv ta te th tr uk wa zh_CN zh_TW"
39 +PLOCALE_BACKUP="en"
40 +
41 +inherit autotools eapi7-ver estack eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx xdg-utils
42 +
43 +MY_PN="${PN%%-*}"
44 +MY_P="${MY_PN}-${PV}"
45 +
46 +if [[ ${PV} == "9999" ]] ; then
47 + EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
48 + EGIT_BRANCH="master"
49 + inherit git-r3
50 + SRC_URI=""
51 + #KEYWORDS=""
52 +else
53 + MAJOR_V=$(ver_cut 1)
54 + SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.x/${MY_P}.tar.xz"
55 + KEYWORDS="-* ~amd64 ~x86"
56 +fi
57 +S="${WORKDIR}/${MY_P}"
58 +
59 +GWP_V="20191222"
60 +PATCHDIR="${WORKDIR}/gentoo-wine-patches"
61 +
62 +DESCRIPTION="Free implementation of Windows(tm) on Unix, without external patchsets"
63 +HOMEPAGE="https://www.winehq.org/"
64 +SRC_URI="${SRC_URI}
65 + https://dev.gentoo.org/~sarnex/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
66 +"
67 +
68 +LICENSE="LGPL-2.1"
69 +SLOT="${PV}"
70 +IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags dos elibc_glibc +faudio +fontconfig +gecko gphoto2 gsm gssapi gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap +mono mp3 ncurses netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner sdl selinux +ssl test +threads +truetype udev +udisks +unwind v4l vkd3d vulkan +X +xcomposite xinerama +xml"
71 +REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
72 + X? ( truetype )
73 + elibc_glibc? ( threads )
74 + osmesa? ( opengl )
75 + test? ( abi_x86_32 )
76 + vkd3d? ( vulkan )" # osmesa-opengl #286560 # X-truetype #551124
77 +
78 +# FIXME: the test suite is unsuitable for us; many tests require net access
79 +# or fail due to Xvfb's opengl limitations.
80 +RESTRICT="test"
81 +
82 +COMMON_DEPEND="
83 + X? (
84 + x11-libs/libXcursor[${MULTILIB_USEDEP}]
85 + x11-libs/libXext[${MULTILIB_USEDEP}]
86 + x11-libs/libXfixes[${MULTILIB_USEDEP}]
87 + x11-libs/libXrandr[${MULTILIB_USEDEP}]
88 + x11-libs/libXi[${MULTILIB_USEDEP}]
89 + x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
90 + )
91 + alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
92 + capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
93 + cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
94 + faudio? ( app-emulation/faudio:=[${MULTILIB_USEDEP}] )
95 + fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
96 + gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
97 + gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
98 + gssapi? ( virtual/krb5[${MULTILIB_USEDEP}] )
99 + gstreamer? (
100 + media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
101 + media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
102 + )
103 + jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
104 + kerberos? ( virtual/krb5[${MULTILIB_USEDEP}] )
105 + lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
106 + ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
107 + mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
108 + ncurses? ( >=sys-libs/ncurses-5.2:0=[${MULTILIB_USEDEP}] )
109 + netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
110 + nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
111 + odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
112 + openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
113 + opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
114 + opengl? (
115 + virtual/glu[${MULTILIB_USEDEP}]
116 + virtual/opengl[${MULTILIB_USEDEP}]
117 + )
118 + osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
119 + pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
120 + png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
121 + pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
122 + scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
123 + sdl? ( media-libs/libsdl2:=[haptic,joystick,${MULTILIB_USEDEP}] )
124 + ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
125 + truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
126 + udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
127 + udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
128 + unwind? ( sys-libs/libunwind[${MULTILIB_USEDEP}] )
129 + v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
130 + vkd3d? ( app-emulation/vkd3d[${MULTILIB_USEDEP}] )
131 + vulkan? ( media-libs/vulkan-loader[${MULTILIB_USEDEP}] )
132 + xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
133 + xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
134 + xml? (
135 + dev-libs/libxml2[${MULTILIB_USEDEP}]
136 + dev-libs/libxslt[${MULTILIB_USEDEP}]
137 + )"
138 +
139 +RDEPEND="${COMMON_DEPEND}
140 + app-emulation/wine-desktop-common
141 + >app-eselect/eselect-wine-0.3
142 + !app-emulation/wine:0
143 + dos? ( >=games-emulation/dosbox-0.74_p20160629 )
144 + gecko? ( app-emulation/wine-gecko:2.47.1[abi_x86_32?,abi_x86_64?] )
145 + mono? ( app-emulation/wine-mono:5.0.0 )
146 + perl? (
147 + dev-lang/perl
148 + dev-perl/XML-Simple
149 + )
150 + pulseaudio? (
151 + realtime? ( sys-auth/rtkit )
152 + )
153 + samba? ( >=net-fs/samba-3.0.25[winbind] )
154 + selinux? ( sec-policy/selinux-wine )
155 + udisks? ( sys-fs/udisks:2 )"
156 +
157 +# tools/make_requests requires perl
158 +DEPEND="${COMMON_DEPEND}
159 + sys-devel/flex
160 + >=sys-kernel/linux-headers-2.6
161 + virtual/pkgconfig
162 + virtual/yacc
163 + X? ( x11-base/xorg-proto )
164 + prelink? ( sys-devel/prelink )
165 + xinerama? ( x11-base/xorg-proto )"
166 +
167 +# These use a non-standard "Wine" category, which is provided by
168 +# /etc/xdg/applications-merged/wine.menu
169 +QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
170 +usr/share/applications/wine-notepad.desktop
171 +usr/share/applications/wine-uninstaller.desktop
172 +usr/share/applications/wine-winecfg.desktop"
173 +
174 +PATCHES=(
175 + "${PATCHDIR}/patches/${MY_PN}-5.0-winegcc.patch" #260726
176 + "${PATCHDIR}/patches/${MY_PN}-4.7-multilib-portage.patch" #395615
177 + "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
178 +)
179 +PATCHES_BIN=()
180 +
181 +# https://bugs.gentoo.org/show_bug.cgi?id=635222
182 +if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
183 + DEPEND+=" dev-util/patchbin"
184 +fi
185 +
186 +wine_compiler_check() {
187 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
188 +
189 + # GCC-specific bugs
190 + if tc-is-gcc; then
191 + # bug #549768
192 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
193 + ebegin "Checking for gcc-5 ms_abi compiler bug"
194 + $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
195 + # Run in subshell to prevent "Aborted" message
196 + ( "${T}"/pr66838 || false ) >/dev/null 2>&1
197 + if ! eend $?; then
198 + eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
199 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
200 + eerror "or use gcc-config to select a different compiler version."
201 + eerror "See https://bugs.gentoo.org/549768"
202 + eerror
203 + return 1
204 + fi
205 + fi
206 + # bug #574044
207 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
208 + ebegin "Checking for gcc-5-3 stack realignment compiler bug"
209 + # Compile in subshell to prevent "Aborted" message
210 + ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
211 + if ! eend $?; then
212 + eerror "Wine cannot be built with this version of gcc-5.3"
213 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
214 + eerror "or use gcc-config to select a different compiler version."
215 + eerror "See https://bugs.gentoo.org/574044"
216 + eerror
217 + return 1
218 + fi
219 + fi
220 + fi
221 +
222 + # Ensure compiler support
223 + if use abi_x86_64; then
224 + ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
225 + # Compile in subshell to prevent "Aborted" message
226 + ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
227 + if ! eend $?; then
228 + eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
229 + eerror
230 + eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
231 + eerror
232 + return 1
233 + fi
234 + fi
235 +}
236 +
237 +wine_build_environment_check() {
238 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
239 +
240 + if use abi_x86_64; then
241 + if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
242 + eerror "You need gcc-4.4+ to compile 64-bit wine"
243 + die
244 + elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
245 + eerror "You need clang-3.8+ to compile 64-bit wine"
246 + die
247 + fi
248 + fi
249 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
250 + ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
251 + ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
252 + ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
253 + fi
254 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
255 + if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
256 + ewarn "Compilation can hang with CFLAGS=\"-march=i686\". You can temporarily work"
257 + ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
258 + ewarn "See package.env in man 5 portage for more information on how to do this."
259 + ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
260 + fi
261 + fi
262 +
263 + if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
264 + eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
265 + eerror "See https://bugs.gentoo.org/487864 for more details."
266 + eerror
267 + return 1
268 + fi
269 +}
270 +
271 +wine_env_vcs_vars() {
272 + local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
273 + local pn_live_val="${pn_live_var}"
274 + eval pn_live_val='$'${pn_live_val}
275 + if [[ ! -z ${EGIT_COMMIT} ]]; then
276 + eerror "Commits must now be specified using the environmental variables"
277 + eerror "EGIT_OVERRIDE_COMMIT_WINE"
278 + eerror
279 + return 1
280 + fi
281 +}
282 +
283 +pkg_pretend() {
284 + wine_build_environment_check || die
285 +
286 + # Verify OSS support
287 + if use oss && ! use kernel_FreeBSD; then
288 + if ! has_version ">=media-sound/oss-4"; then
289 + eerror "You cannot build wine with USE=oss without having support from a"
290 + eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
291 + eerror
292 + die
293 + fi
294 + fi
295 +}
296 +
297 +pkg_setup() {
298 + wine_build_environment_check || die
299 + wine_env_vcs_vars || die
300 +
301 + WINE_VARIANT="${PN#wine}-${PV}"
302 + WINE_VARIANT="${WINE_VARIANT#-}"
303 +
304 + MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
305 + MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
306 + MY_DATADIR="${MY_DATAROOTDIR}"
307 + MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
308 + MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
309 + MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
310 + MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
311 + MY_MANDIR="${MY_DATADIR}/man"
312 +}
313 +
314 +src_unpack() {
315 + if [[ ${PV} == "9999" ]] ; then
316 + EGIT_CHECKOUT_DIR="${S}" git-r3_src_unpack
317 + fi
318 +
319 + default
320 +
321 + l10n_find_plocales_changes "${S}/po" "" ".po"
322 +}
323 +
324 +src_prepare() {
325 +
326 + eapply_bin(){
327 + local patch
328 + for patch in ${PATCHES_BIN[@]}; do
329 + patchbin --nogit < "${patch}" || die
330 + done
331 + }
332 +
333 + local md5="$(md5sum server/protocol.def)"
334 +
335 + default
336 + eapply_bin
337 + eautoreconf
338 +
339 + # Modification of the server protocol requires regenerating the server requests
340 + if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
341 + einfo "server/protocol.def was patched; running tools/make_requests"
342 + tools/make_requests || die #432348
343 + fi
344 + sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
345 + if ! use run-exes; then
346 + sed -i '/^MimeType/d' loader/wine.desktop || die #117785
347 + fi
348 +
349 + # Edit wine.desktop to work for specific variant
350 + sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
351 +
352 + # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
353 + cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
354 +
355 + l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
356 +
357 + # Fix manpage generation for locales #469418 and abi_x86_64 #617864
358 +
359 + # Duplicate manpages input files for wine64
360 + local f
361 + for f in loader/*.man.in; do
362 + cp ${f} ${f/wine/wine64} || die
363 + done
364 + # Add wine64 manpages to Makefile
365 + if use abi_x86_64; then
366 + sed -i "/wine.man.in/i \
367 + \\\twine64.man.in \\\\" loader/Makefile.in || die
368 + sed -i -E 's/(.*wine)(.*\.UTF-8\.man\.in.*)/&\
369 +\164\2/' loader/Makefile.in || die
370 + fi
371 +
372 + rm_man_file(){
373 + local file="${1}"
374 + loc=${2}
375 + sed -i "/${loc}\.UTF-8\.man\.in/d" "${file}" || die
376 + }
377 +
378 + while read f; do
379 + l10n_for_each_disabled_locale_do rm_man_file "${f}"
380 + done < <(find -name "Makefile.in" -exec grep -q "UTF-8.man.in" "{}" \; -print)
381 +}
382 +
383 +src_configure() {
384 + wine_compiler_check || die
385 +
386 + export LDCONFIG=/bin/true
387 + use custom-cflags || strip-flags
388 +
389 + multilib-minimal_src_configure
390 +}
391 +
392 +multilib_src_configure() {
393 + local myconf=(
394 + --prefix="${MY_PREFIX}"
395 + --datarootdir="${MY_DATAROOTDIR}"
396 + --datadir="${MY_DATADIR}"
397 + --docdir="${MY_DOCDIR}"
398 + --includedir="${MY_INCLUDEDIR}"
399 + --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
400 + --libexecdir="${MY_LIBEXECDIR}"
401 + --localstatedir="${MY_LOCALSTATEDIR}"
402 + --mandir="${MY_MANDIR}"
403 + --sysconfdir="${EPREFIX}/etc/wine"
404 + $(use_with alsa)
405 + $(use_with capi)
406 + $(use_with lcms cms)
407 + $(use_with cups)
408 + $(use_with ncurses curses)
409 + $(use_with udisks dbus)
410 + $(use_with faudio)
411 + $(use_with fontconfig)
412 + $(use_with ssl gnutls)
413 + $(use_enable gecko mshtml)
414 + $(use_with gphoto2 gphoto)
415 + $(use_with gsm)
416 + $(use_with gssapi)
417 + $(use_with gstreamer)
418 + --without-hal
419 + $(use_with jpeg)
420 + $(use_with kerberos krb5)
421 + $(use_with ldap)
422 + --without-mingw # linux LDFLAGS leak in mingw32: bug #685172
423 + $(use_enable mono mscoree)
424 + $(use_with mp3 mpg123)
425 + $(use_with netapi)
426 + $(use_with nls gettext)
427 + $(use_with openal)
428 + $(use_with opencl)
429 + $(use_with opengl)
430 + $(use_with osmesa)
431 + $(use_with oss)
432 + $(use_with pcap)
433 + $(use_with png)
434 + $(use_with pulseaudio pulse)
435 + $(use_with threads pthread)
436 + $(use_with scanner sane)
437 + $(use_with sdl)
438 + $(use_enable test tests)
439 + $(use_with truetype freetype)
440 + $(use_with udev)
441 + $(use_with unwind)
442 + $(use_with v4l v4l2)
443 + $(use_with vkd3d)
444 + $(use_with vulkan)
445 + $(use_with X x)
446 + $(use_with X xfixes)
447 + $(use_with xcomposite)
448 + $(use_with xinerama)
449 + $(use_with xml)
450 + $(use_with xml xslt)
451 + )
452 +
453 + local PKG_CONFIG AR RANLIB
454 + # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
455 + # set AR and RANLIB to make QA scripts happy; #483342
456 + tc-export PKG_CONFIG AR RANLIB
457 +
458 + if use amd64; then
459 + if [[ ${ABI} == amd64 ]]; then
460 + myconf+=( --enable-win64 )
461 + else
462 + myconf+=( --disable-win64 )
463 + fi
464 +
465 + # Note: using --with-wine64 results in problems with multilib.eclass
466 + # CC/LD hackery. We're using separate tools instead.
467 + fi
468 +
469 + ECONF_SOURCE=${S} \
470 + econf "${myconf[@]}"
471 + emake depend
472 +}
473 +
474 +multilib_src_test() {
475 + # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
476 + if [[ ${ABI} == x86 ]]; then
477 + if [[ $(id -u) == 0 ]]; then
478 + ewarn "Skipping tests since they cannot be run under the root user."
479 + ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
480 + return
481 + fi
482 +
483 + WINEPREFIX="${T}/.wine-${ABI}" \
484 + Xemake test
485 + fi
486 +}
487 +
488 +multilib_src_install_all() {
489 + local DOCS=( ANNOUNCE AUTHORS README )
490 + add_locale_docs() {
491 + local locale_doc="documentation/README.$1"
492 + [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
493 + }
494 + l10n_for_each_locale_do add_locale_docs
495 +
496 + einstalldocs
497 + prune_libtool_files --all
498 +
499 + if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
500 + rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
501 + "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
502 + fi
503 +
504 + # Remove wineconsole if neither backend is installed #551124
505 + if ! use X && ! use ncurses; then
506 + rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
507 + rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
508 + rm_wineconsole() {
509 + rm "${D%/}${MY_PREFIX}/$(get_libdir)"/wine/{,fakedlls/}wineconsole.exe* || die
510 + }
511 + multilib_foreach_abi rm_wineconsole
512 + fi
513 +
514 + use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
515 + use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
516 +
517 + # Avoid double prefix from dosym and make_wrapper
518 + MY_PREFIX=${MY_PREFIX#${EPREFIX}}
519 +
520 + if use abi_x86_64 && ! use abi_x86_32; then
521 + dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
522 + dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
523 + fi
524 +
525 + # Failglob for binloops, shouldn't be necessary, but including to stay safe
526 + eshopts_push -s failglob #615218
527 + # Make wrappers for binaries for handling multiple variants
528 + # Note: wrappers instead of symlinks because some are shell which use basename
529 + local b
530 + for b in "${ED%/}${MY_PREFIX}"/bin/*; do
531 + make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
532 + done
533 + eshopts_pop
534 +}
535 +
536 +pkg_postinst() {
537 + eselect wine register ${P}
538 + if [[ ${PN} == "wine-vanilla" ]]; then
539 + eselect wine register --vanilla ${P} || die
540 + fi
541 +
542 + eselect wine update --all --if-unset || die
543 +
544 + xdg_desktop_database_update
545 +
546 + if ! use gecko; then
547 + ewarn "Without Wine Gecko, wine prefixes will not have a default"
548 + ewarn "implementation of iexplore. Many older windows applications"
549 + ewarn "rely upon the existence of an iexplore implementation, so"
550 + ewarn "you will likely need to install an external one, like via winetricks"
551 + fi
552 + if ! use mono; then
553 + ewarn "Without Wine Mono, wine prefixes will not have a default"
554 + ewarn "implementation of .NET. Many windows applications rely upon"
555 + ewarn "the existence of a .NET implementation, so you will likely need"
556 + ewarn "to install an external one, like via winetricks"
557 + fi
558 +}
559 +
560 +pkg_prerm() {
561 + eselect wine deregister ${P}
562 + if [[ ${PN} == "wine-vanilla" ]]; then
563 + eselect wine deregister --vanilla ${P} || die
564 + fi
565 +
566 + eselect wine update --all --if-unset || die
567 +}
568 +
569 +pkg_postrm() {
570 + xdg_desktop_database_update
571 +}